<?php

/**
 This project has been generated by worker generator
 has been made by fahmi sulaiman
 sulaimanfahmi@gmail.com
 check out my github @dekaulitz
 */
namespace App\Http\Validators;

use App\Http\Base\Validation;

class UsersValidator extends Validation
{
    /**
    * this function will call before insert, you can custom as your business requirement
    * @param array $input
    * @return $this
    */
    public function beforeInsert($input){
		if(empty($input["username"])){
			array_push($this->error, ["username" => "cannot be null"]);
		}
		else{
			$lengthusername = strlen($input["username"]);
			if($lengthusername>100){
			array_push($this->error, ["username" => "value too long"]);
			}
		}
		if(!empty($input["username"])){
			$username= (new \App\Http\Models\UsersModel())->getQuery()
			->where("users.username","=",$input["username"])->first();
			if(($username)){
			array_push($this->error, ["username" => "Value Already Exist"]);
			}
		}
		if(empty($input["roleId"])){
			array_push($this->error, ["roleId" => "cannot be null"]);
		}
		else{
			$lengthroleid = strlen($input["roleId"]);
			if($lengthroleid>19){
			array_push($this->error, ["roleid" => "value too long"]);
			}
			$roles= (new \App\Http\Models\RolesModel())
			->getQuery()->where("id","=",$input["roleId"])->first();
			if(empty($roles)){
				array_push($this->error, ["roleId" => "invalid relation"]);
			}
		}	
		if(empty($input["name"])){
			array_push($this->error, ["name" => "cannot be null"]);
		}
		else{
			$lengthname = strlen($input["name"]);
			if($lengthname>200){
			array_push($this->error, ["name" => "value too long"]);
			}
		}
		if(empty($input["password"])){
			array_push($this->error, ["password" => "cannot be null"]);
		} else if(empty($input["re-password"])){
			array_push($this->error, ["re-password" => "cannot be null"]);
		} else if($input["re-password"] != $input["password"]){
			array_push($this->error, ["password" => "password not match"]);
		} else{
			$lengthpassword = strlen($input["password"]);
			if($lengthpassword>100){
			array_push($this->error, ["password" => "value too long"]);
			}
		}
		if(!empty($input["nrp"])){
			$nrpLength = strlen($input["nrp"]);
			if($nrpLength != 5){
				array_push($this->error, ["nrp" => "Value must be 5 digits"]);
			}
		}

        return $this;
    }

    /**
    * this function will call before update into database, you can custom as your business requirement
    * @param array $input
    * @param $id
    * @return $this
    */
    public function beforeUpdate($input,$id){
		if(empty($input["username"])){
			array_push($this->error, ["username" => "cannot be null"]);
		}
		else{
			$lengthusername = strlen($input["username"]);
			if($lengthusername>100){
			array_push($this->error, ["username" => "value too long"]);
			}
		}
		if(!empty($input["username"])){
			$username= (new \App\Http\Models\UsersModel())->getQuery()
			->where("users.username","=",$input["username"])->first();
			if(($username)&& ($id !=$username->id)){
			array_push($this->error, ["username" => "Value Already Exist"]);
			}
		}
		if(empty($input["roleId"])){
			array_push($this->error, ["roleId" => "cannot be null"]);
		}
		else{
			$lengthroleid = strlen($input["roleId"]);
			if($lengthroleid>19){
			array_push($this->error, ["roleid" => "value too long"]);
			}
		}
		if(!empty($input["roleId"])){
		$roles= (new \App\Http\Models\RolesModel())
			->getQuery()->where("id","=",$input["roleId"])->first();
		if(empty($roles)){
			array_push($this->error, ["roleId" => "invalid relation"]);
		}
		}
		if(empty($input["name"])){
			array_push($this->error, ["name" => "cannot be null"]);
		}
		else{
			$lengthname = strlen($input["name"]);
			if($lengthname>200){
			array_push($this->error, ["name" => "value too long"]);
			}
		}/* 
		if(empty($input["password"])){
			array_push($this->error, ["password" => "cannot be null"]);
		}
		else{
			$lengthpassword = strlen($input["password"]);
			if($lengthpassword>100){
			array_push($this->error, ["password" => "value too long"]);
			}
		} */

        return $this;
    }

    /**
    * this function will call before delete from database, you can custom as your business requirement
    * @param $id
    * @return $this
    */
    public function beforeDelete($id){
	return $this;

	}
	

	public function beforeUpdatePassword($input,$id){
		$username= (new \App\Http\Models\UsersModel())->getQuery()->where("users.id","=",$id)->first();
		if(! $username) {
			array_push($this->error, ["username" => "User is not found"]);
		}

		if(empty($input["password"])){
			array_push($this->error, ["password" => "cannot be null"]);
		} else if(empty($input["re-password"])){
			array_push($this->error, ["re-password" => "cannot be null"]);
		} else if($input["re-password"] != $input["password"]){
			array_push($this->error, ["password" => "password not match"]);
		} else{
			$lengthpassword = strlen($input["password"]);
			if($lengthpassword > 100){
				array_push($this->error, ["password" => "value too long"]);
			}
		}

        return $this;
    }


}